/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of this file
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern void scopy(char *d, const char *s);

char *catstr(const char *pth,const char *fnam, char chr) /* chr 一般是'/' */
{
unsigned int len=pth? strlen(pth):0;
char *chs=(char *)malloc(len+strlen(fnam)+5);
if(pth)scopy(chs,pth);
if(chr && (len==0 || chs[len-1]!=chr) )chs[len++]=chr;
scopy(chs+len, fnam);
return chs;
}

char *_ProgPath;
FILE *PathOpen(const char *fnm,const char *fmode)
{
FILE *fp;
const char *pt=(char *)fnm;
start: fp=fopen(pt,fmode);
if(fp==NULL){
	if(pt==fnm&&_ProgPath){
		pt=catstr(_ProgPath,fnm, 0);
		goto start;
		}
	}
if(pt!=fnm)free((void *)pt);
return fp;
}

unsigned  FmtText(char *buf,unsigned  len)
{
  register unsigned  i;
  for(i=0;i<len;i++)switch(buf[i]){
	case '\r' : if(buf[i+1]=='\n'){
		  register  unsigned j;
		  for(j=i; j<len; j++)buf[j]=buf[j+1];
		  len--;
		}
		else buf[i]='\n';
		break;
	case 9 : buf[i]=32;
	}
  return len;
}

char *ReadFile(const char *fname,unsigned int *filelen)
{
unsigned int len;
char *buf;
FILE *fp=PathOpen(fname,"rb");
if(fp==NULL){ perror(fname); return NULL; }
 else {/* open ok */
  fseek(fp,0,2);  len=ftell(fp);
  buf=(char *)malloc(len+4);
  if(buf==NULL){
	puts("Fail to alloc memory !");
	fclose(fp);	return NULL;
	}
  rewind(fp);
  len=fread(buf,1,len,fp);
  fclose(fp);	buf[len]=0;
  *filelen=FmtText(buf,len);
return buf;
	}
}

