/*
	Write by xempo Nov 2015
	Free under LGPL
*/

#ifndef		_FAST_BLOCK_
#define		_FAST_BLOCK_

enum FastBlockMode {
AllNoFree=1,  // 用于 FastBlock(char **)
NoFree=2, /* no free(buf);  as getUsrs() */
CombList=3,
OnlyAdd=7, // 用于Filesor的导向（向前或向后）, 可重复
Brows=OnlyAdd,
AppenAlone=9,  // Filesor中文件属性项，可重复添，并加速, 它中途不处理分隔, 没生成list(only)。一次性使用
__AppenAlone=8 // 与上面相似，只是预分配少。
};

class _FastBlock
{
protected :
_FastBlock(int m=0, int limit=0x7fffff00);
~_FastBlock();

virtual int add(const char *txt, const char *div)=0;  // return add pos

int _memDiv(const char *dv_chr);/* dv_chr指分隔符, 内部调用时一般为0（无效） */

void _rem(int idx); // buf no change, list[...] order change

void _resetMem(char *dat, const char *div_chr=NULL);

// virtual void virfun(int idx)=0;

char **list, *buf;
unsigned int  alen, // pre-alloc len
	len;
int mode, lmt, /* limit cnt */
	cnt, mcnt; // mem pre-alloc, for cnt

private :
int  opm;
};

#endif

