/*
	Write by xempo 2014
	Free under LGPL
*/

#include "settingwidget.h"
#include "../rtdata/en/target/setting.h"

SettingWidget::SettingWidget(QWidget *par, const char *nam) :
	QWidget(par, nam, WDestructiveClose|WType_TopLevel),
	fntSz(baseHeight)
//, _H(fntSz*135/100)
{
setFont(par->font());
}

void SettingWidget::execu(const int w, const int h, const int id)
{
static const char *slot[2]={ SLOT(Sure()), SLOT(close()) };
int W, H;
_setting_=charsFromFSP(id);
setFixedSize( W=scalefloat(w), H=scalefloat(h) );
tabwdg=new QTabWidget(this);
tabh=H-(2+3)*fntSz; tabw=W-2*fntSz;
tabwdg->setGeometry( fntSz, fntSz, tabw,  tabh );

QPushButton *Btn[2];
createBtns(this, Btn, _setting_, 2, W, H-3*fntSz, slot, NULL);
sureBtn=Btn[0];
cancelBtn=Btn[1];
setCaption(QString::fromUtf8( _setting_[2] ));
}

SettingWidget::~SettingWidget()
{
free((void *)_setting_[0]);
free((void *)_setting_);
}
