/*
	Write & edit by Linjianghua(xempo)
	Free under LGPL
*/

#define	stricmp	strcasecmp

#include "_readfile.c"

#define	BOOL 	int
#define	True	1
#define	False	0

#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <stdlib.h>
#include "memstr.c"
#include "strdel.c"
#include "fmtinp.c"
#include "setargv.c"

#include "filter.c"

static const char operaChs[]="operator", DEF[]="define";

inline void bepure(char *txt)
{
int i=0, j, L;
while( txt[i] ){
  switch(txt[i]){
  case '/' : if(txt[i+1]=='/'){
	j=i+2;
	_del_:	while( txt[j]!='\n'&&txt[j]!=0)j++;
		strdel(txt+i, j-i);
	}
	break;
  case '#' : if(i==0||txt[i-1]==10){
		for(j=i+1; txt[j]==32; j++);
		L=strlen(DEF);
		if(memcmp(DEF, txt+j, L)==0&&txt[j+L]==32)goto _out_;
		goto _del_;
		}
	}
_out_: i++;
  }
/*return i;*/
}

inline int bepure2(char *txt)
{
int i, j, len, zxpos=-1, yhpos=-1,
	zxcn=0, yhcn=0;
for(i=0; txt[i]; i++){
  if(zxpos>-1){
	if(txt[i]=='\n' )zxcn++;
	}
  else if(txt[i]=='\"'){
	if(yhpos>-1){
		len=i+1-yhpos;
		strdel(txt+yhpos,len-yhcn);
		for(j=0; j<yhcn; j++)txt[yhpos+j]='\n';
		i-=len-yhcn;
		yhcn=0;	yhpos=-1;
		}
	else {
		yhpos=i;
		continue;
		}
	}
  if(yhpos>-1){
	if(txt[i]=='\n' )yhcn++;
	}
  else  if(txt[i]=='/'&&txt[i+1]=='*')zxpos=i;
  if(txt[i]=='*'&&txt[i+1]=='/'){
	len=i+2-zxpos;
	strdel(txt+zxpos,len-zxcn);
	for(j=0; j<zxcn; j++)txt[zxpos+j]='\n';
	i-=len-zxcn;
	zxcn=0;	zxpos=-1;
	}
  }
return i;
}

#define	TypeCount		6
static int total_KW, counting_KW,
	fsp_num, noneCnt, *Index, vose;
static FILE *posfp, *funfp;
static const char WB[]="wb", tmplate[]="template",
*__TypeChs[TypeCount]={ tmplate, "enum",  "class", "struct", "union", "typedef" };

enum Types { Type_Normal, Type_Template, Type_Enum, Type_Class };

static char *srcNam;

/*inline void _handle(int num)
{
printf("Memory error, exiting \"%s\" ...\ntotal : %d , error in line : %d\n" , srcNam, total_KW+counting_KW, *Index);
exit(20);
}*/

static const char *isKeyword(const char *txt, int len, const char *key)
{
const char *ptr;
int L;
return ( (ptr=memstr(txt, len, key, L=strlen(key), 3))!=NULL &&
		(ptr[-1]==10||ptr[-1]==32||ptr==txt) &&
		(ptr[L]==10||ptr[L]==32||ptr[L]=='<') ) ? ptr : NULL;
}

static BOOL dwrite(const char *txt, int len, int pos)
{
if(len>0 && memstr(txt, len, operaChs, sizeof(operaChs)-1, 3)==NULL){
	int i;
	while(len>0 && txt[len-1]==')')len--;
	for(i=0; txt[i]=='('; i++);
	if(len-i>0){
		int j;
		for(j=0; j<len-i; j++)if(txt[i+j]==';'){
			char buf[2000];
			memcpy(buf, txt+i, len-i);
			buf[len-i]=0;			puts(buf);
			printf("Develop on \"%s\" ...\ntotal : %d , error in line : %d\n" , srcNam, total_KW+counting_KW, *Index);
			//exit(20);
			return False;
			}
		fprintf(posfp, counting_KW ? ",%d" : "%d", pos);
		if(counting_KW++>0)fwrite(":", 1, 1, funfp);
		fwrite(txt+i, len-i, 1, funfp);
		return True;
		}
	}
return False;
}

#define  calcLineOff(N)  for(ln=0, k=N; k!=mIdx; k++) \
			if(pt[k]==10)ln++;


static int doCvt(const char *dirsrc, const char *filters, int msg)
{
  char *pt, *ptr, *buf;
  int  spfile, dirLen,
	unitBegin,
	lines,
	pos_idx, fun_idx,
  	namIdx, d, j, n, y, ln, k, syb;
  unsigned int fileLen;
  struct stat st;
  struct dirent *dstru;
  DIR *dir;
  Index=&lines;
  if(stat(dirsrc, &st)){
	perror(dirsrc);
	return -1;
	}
  spfile=!S_ISDIR(st.st_mode);
  if(spfile){ srcNam=(char *)dirsrc; goto _done_; }
  if(!(dir=opendir(dirsrc)) ){
	perror(dirsrc);
	return -1;
	}
  dirLen=strlen(dirsrc);
  srcNam=(char *)malloc(dirLen+258);
  scopy(srcNam, dirsrc);
  if(srcNam[dirLen-1]!='/')srcNam[dirLen++]='/';
  while(spfile==0 && (dstru=readdir(dir)) ){
    ptr=dstru->d_name;
    if((ptr[0]=='.' && (ptr[1]==0 || ptr[1]=='.'&&ptr[2]==0 )) )continue;
    scopy(srcNam+dirLen, ptr);
    stat(srcNam, &st);
    if(S_ISDIR(st.st_mode)){
	if(msg&1)doCvt(srcNam, filters, 1);
	}
    else {
	int mIdx;
	char buff1[1200], buff2[40];
	if( namefilters(ptr, filters, 3)==0 )continue;
//________________________________________________________
_done_:	if( !(buf=ReadFile(srcNam, &fileLen)) )return 3;
	if(spfile==0&&vose)printf("Get total_KW from \"%s\" ...\n", srcNam);
	bepure(buf);
	if( (k=bepure2(buf))<1 ){
		if(vose)printf(" ** %s \n    is none !\n", srcNam);
		noneCnt++;
		continue;
	}
	fileLen=k;
	pt=buf;
	for(j=fileLen-1; j>0&&(pt[j]==10); j--,fileLen--)pt[j]=0;

  pos_idx=ftell(posfp);	fun_idx=ftell(funfp);
  sprintf(buff1, "numbset %d -t=vi\n{\n%s\n}\n{\n", fsp_num, srcNam);
  fseek(posfp, pos_idx+strlen(buff1), 0);
  sprintf(buff2, "write.m: %d ", fsp_num);
  fseek(funfp, fun_idx+strlen(buff2), 0);
  counting_KW=0;  	lines=0;
  unitBegin=0; mIdx=0;/* mem index */
  while(mIdx<fileLen){
	switch(pt[mIdx]){
	case '\n' : lines++;
		break;
	case ';' :  // baseUnit
		while(pt[unitBegin]==10||pt[unitBegin]==32)unitBegin++;
		j=unitBegin;
		while(pt[j]!=',' &&pt[j]!='('&&pt[j]!='='&&j<mIdx)j++;
_loop1_:	namIdx=j-1;
		while(pt[namIdx]==32||pt[namIdx]==10)namIdx--;
		if(pt[namIdx]==']'){ // [xx]
			while(pt[--namIdx]!='[');
			d=namIdx;
			}
		else d=namIdx+1; // Name end
		if(pt[j]=='('){
		      y=j;
		      while(pt[++y]==32||pt[y]==10);
		      if(pt[y]=='*'){ // (*func)(...)
			while(pt[++y]==32||pt[y]==10);
			n=y;
			while(pt[++y]!=')' && pt[y]!='('); /* as:  extern int (*XSetExtensionErrorHandler(int (*handler)(Display *,  char *,   char *   ) ) )
					 (Display *,char *,char *);*/
			syb=pt[y]=='(' ? 2:0;
			j=y;
			while(pt[--y]==32||pt[y]==10);
			//pt[y]=0;
			calcLineOff(n)  // get ln
			dwrite(pt+n, y+1-n, lines-ln);
			goto _through_syb2;
			}
		}
		while(namIdx>=unitBegin&&(pt[namIdx]!=32&&pt[namIdx]!=10&&pt[namIdx]!='*'&&pt[namIdx]!=','))namIdx--; // Name begin
//		  pt[d]=0;
		namIdx++;
		calcLineOff(namIdx)  // get ln
		if(dwrite(pt+namIdx, d-namIdx, lines-ln)==False){
			unitBegin=mIdx+1;
			goto _Loop_;
			}
		switch(pt[j]){
		case '('  : syb=1;
	_through_syb2: while(++j<mIdx){
			switch(pt[j]){
			case '(' : syb++;
				break;
			case ')' : if(--syb==0){
					while(pt[++j]==32||pt[j]==10);
					if(pt[j]=='('){
						syb=1;
						break;
					}
					syb=0;
					while(j<mIdx){
						switch(pt[j]){
						case '(' : syb++;
							break;
						case ')' : --syb;
							break;
						case ',' : if(syb==0)goto _jmp2_;
						}
						j++;
					}
					goto _jmp2_;
					}
				}
			}
		break;
		case ':' :
		case '=' : while(++j<mIdx && pt[j]!=',' && pt[j]!='(' && pt[j] != '=' );
		}
_jmp2_:		unitBegin=++j;
		if(j<mIdx){
			syb=0;
			k=pt[j-1];
			while(j<mIdx){
				switch(pt[j]){
				case '(' : syb++;
					break;
				case ')' : if(--syb==0)unitBegin=j+1;
					break;
				case '=' : 
				case ',' : if(syb==0)goto _loop1_;
				}
				j++;
			}
			if(k==',')goto _loop1_;
		}
		else unitBegin=mIdx+1;
		break;	 // baseUnit end
	case '#' : for(n=mIdx+1; pt[n]==32; n++);
		if( (mIdx==0||pt[mIdx-1]==10) && memstr(pt+n,6, DEF, 6, 3)==pt+n){
		  for(n+=6; pt[n]==32; n++);
		  namIdx=n;
		  while(pt[n]!=32&&pt[n]!='('&&n<fileLen){
			if(pt[n]==10){ lines++; break; }
			n++;
			}
		  d=n;
//		  pt[d]=0;
		  if(pt[n]=='('){
		      syb=1;
		      while(++n<fileLen){
			switch(pt[n]){
			case '(' : syb++; break;
			case 10 : lines++; break;
			case ')' : if(--syb==0)goto _jmp3_;
			}
		      }
		  }
_jmp3_:		  dwrite(pt+namIdx, d-namIdx, pt[n]==10 ? lines-1 : lines);
		  while( ++n<fileLen )
		      if( 10==pt[n]){
			lines++;
			for(j=n-1;j>0&&(pt[j]==32);j--);
			if(pt[j]!='\\')goto _brk_;
			}
		} // end if
	_brk_:	mIdx=n;	unitBegin=mIdx+1;
		break;
	case '{' : { /* ________________pt[mIdx]=={' _____________________ */
		int  __type=0, __syb=0, _line=0, head_off=0;
		register int __mIdx;
		syb=1; pt[mIdx]=32;
		__mIdx=mIdx;
		while(pt[--__mIdx]==32||pt[__mIdx]==10)if(pt[__mIdx]==10)head_off++;
		if(pt[__mIdx]==')') /* inline */
			goto _inline_;
		for(j=0; j<TypeCount; j++)
		  if( isKeyword(pt+unitBegin, mIdx-unitBegin, __TypeChs[j]) ){
			__type=j+1;
			break;
			}
		switch(__type){
		case Type_Template :
			for(n=unitBegin; pt[n]!='>'; n++){
				if(pt[n]==10)lines++;
				}
			n++;
			while(pt[n]==10||pt[n]==32){
				if(pt[n]==10)lines++;
				n++;
				}
			while(pt[n]!=32){
				if(pt[n]==10){lines++; break; }
				n++;
				}
//-----------------------------------------------------------------------------------------------------
			while(pt[n]==10||pt[n]==32){
				if(pt[n]==10)lines++;
				n++;
				}
			for(j=n; pt[j]!=32&&pt[j]!='('; j++)
				if(pt[j]==10){ lines++; break; }
			if(memstr(pt+n, j-n, operaChs, 8, 3)!=pt+n)dwrite(pt+n, j-n, lines); // write 2nd
			for(n=mIdx+1 ; n<fileLen; n++)
			  switch(pt[n]){
			  case '{' : syb++;
				break;
			  case 10 : lines++; break;
			  case '}' : if(--syb==0){
					while(pt[++n]==32||pt[n]==10);
					while( pt[n]!=';'&& n<mIdx ) n++;
					mIdx=n+1;
					unitBegin=n;
					goto _Loop_;
				}
			  }
			break;
		case Type_Class : ptr=memstr(pt+unitBegin, mIdx-unitBegin, ":", 1, 1);
			if(ptr==NULL)ptr=pt+__mIdx+1;
			__syb=0xff;
			while( *(--ptr)==32 ||*ptr==10)if(*ptr==10)_line--;
			for(d=0; *ptr != 32;  d++, ptr--)
				if(*ptr==10){ _line--; break; }
			dwrite(ptr+1, d, lines+_line-head_off);
			break;
		case Type_Normal ://	n=__mIdx+1; /* only proc inline */
			while(/*pt[__mIdx]!=')'&&*/__mIdx>unitBegin){//__mIdx--;
			    if(pt[__mIdx]==')')_inline_:{
				k=1;
				while(__mIdx>unitBegin)
				switch(pt[--__mIdx]){
				case ')' : k++;
					break;
				case 10 : _line--;
					break;
				case '(' : if(--k==0){
					while(pt[--__mIdx]==32||pt[__mIdx]==10)if(pt[__mIdx]==10)_line--;
					j=__mIdx;
					while(pt[--__mIdx]!=32 && pt[__mIdx]!=10&&pt[__mIdx]!='*'&&pt[__mIdx]!='&');
					if(isKeyword(pt+__mIdx+1, j-__mIdx, "__NTH")==NULL)
						dwrite(pt+__mIdx+1, j-__mIdx, lines+_line-head_off);
					for(n=mIdx+1 ; n<fileLen; n++)
					switch(pt[n]){
					case '\n' : lines++;
						break;
					case '{' : syb++;
						break;
					case '}' : if(--syb==0){
						mIdx=n;	goto _ex_loop_;
						}
					}
				     }
				}
				break;
			    } /* _inline_  end */
			    __mIdx--;
			}
		} /* end switch(__type) */
		for(n=mIdx+1 ; n<fileLen; n++)
		switch(pt[n]){
		case '{' : syb++;
			break;
		case ':' : if(__type==Type_Class)/* class, like  public: or private : */
				pt[n]=32;
			else pt[n]='=';
			break;
		case 10 : _line++;
			break;
		case '}' : if(--syb==0){ // 解括号成功
			pt[n]=32;
			if(__type==Type_Normal)goto _ex_loop_;
			k=n;
			while(pt[++n]==32||pt[n]==10)if(pt[n]==10)_line++;
			for(j=n; pt[j]!=';'&&j<fileLen; j++);
			if(__type!=Type_Enum)pt[j]=32; // enum reserve ';'
			if(__syb>0xf0)goto _ex_loop_;
			namIdx=j-1;
			while( k!=namIdx&&(pt[namIdx]==32||pt[namIdx]==10) )namIdx--;
			j=namIdx+1;
			while(pt[namIdx]!=32&& pt[namIdx]!=10&&pt[namIdx]!='*'&&k!=namIdx)namIdx--;
			namIdx++;	
			if(j-namIdx>0)dwrite(pt+namIdx, j-namIdx, lines+_line);
			else { // goto head
				for(d=__mIdx++; pt[d]!=32&&pt[d]!=10; d--);
				dwrite(pt+(d+1), __mIdx-(d+1), lines-head_off);
			}
			_ex_loop_: unitBegin=mIdx+1;
			goto _Loop_;
			}
		  }
		}/*______pt[mIdx]=={' end _____________________ */
	}
_Loop_:   mIdx++;
  }

  if(counting_KW){
	fprintf(funfp,"\n\n");
	fprintf(posfp,"\n}\n\n");

	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);

	fprintf(posfp, buff1);
	fprintf(funfp, buff2);
	fseek(posfp, 0, 2);
	fseek(funfp, 0, 2);
	fsp_num++;
	if(spfile==0&&vose)printf("    ==> %d\n", counting_KW);
	total_KW+=counting_KW;
	}
  else {
	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);
	}
  }
  }
  if(spfile==0)closedir(dir);
return 0; // success
}

#define	dstdir	dyVar[0]
#define	spfile	dyVar[1]
#define	outfile	dyVar[2]
#define  varsCnt	3
#define  pmsCnt	5

int main(int argc, char **argv)
{
static const char usageChs[]="Cvt C/C++ head file for runtime-help\n\
Usage : mkhlp [Dir|-f <src-file>] | [-d <out-dir>|-o <out-file>] | [--filters=xxx]\n\
      |[--vose] |[--sub] |[--nowarn] |[--disnw]\n\
Options :\n\
      Dir is input <src-dir>. if a file, must use -f, follow <out-file>\n\
      -d follow <out-dir>, or -o follow <out-file>\n\
      --vose : show message\n\
      --sub : include subdir\n\
      --nowarn : no warn for source\n\
      --disnw : disable next warn \n\
      default create \"helpfun.fss\" & \"helppos.fss\"\n";

if(argc>1){
  static const char *paras[pmsCnt]={ "--vose" , "--sub", "--nowarn", "--disnw", "--filters=" }, /* save parasVal[] */
	*vars[varsCnt]={"-d" , "-f", "-o"},
	*lostdst[3]={"A dir must follow \"%s\" for out !\n",
		"A file must follow \"%s\" as source !\n",
		"A file must follow \"%s\" as outfile !\n",
	},
	*warnMult[3]={"Out dir has specied \"%s\", \"%s\" not be use !\n",
		"Source file specied \"%s\", \"%s\" not be use !\n",
		"Out file has specied \"%s\", \"%s\" not be use !\n"
	};
  char *pt;
  struct stat st; 
  int pmIdx, *pmpos,   j,  i,
	parasVal[pmsCnt]={0,0,0,0,0 };  /* => params index; */
  const char  *dyVar[varsCnt],  *dirsrc=NULL, *filters=NULL,
 *funfile="helpfun.fss", *posfile="helppos.fss"; /*default create 2 files */
 memset(dyVar, 0, varsCnt*sizeof(char *));
 pmpos=(int *)malloc(sizeof(int)*(argc-1));
 for(i=0; i<argc-1; i++)pmpos[i]=-1;
 pmIdx=0;
 for(i=1; i<argc; i++){
      for(j=0; j<varsCnt; j++)if(strcmp(vars[j], argv[i])==0){
	if( i+1>=argc ){
		if(dyVar[j]==NULL){
			printf(lostdst[j], vars[j]);
			pmpos[pmIdx++]=i;
		}
		continue;
		}
	pmpos[pmIdx++]=i++;
	switch(j){
	case 0 :	if(stat(argv[i], &st) || !S_ISDIR(st.st_mode) ){
			printf("\"-d\" specied \"%s\" is not existed dir !\n", argv[i]);
			goto _jmp_;
			}
		break;
	case 1 :	if(stat(argv[i], &st) || S_ISDIR(st.st_mode) ){
			printf("\"-f\" specied \"%s\" is not existed file !\n", argv[i]);
			goto _jmp_;
			}
/*		break; */
	}
	if(dyVar[j])printf(warnMult[j], dyVar[j], argv[i]);
	else dyVar[j]=argv[i];
	_jmp_: pmpos[pmIdx++]=i;
	break;
	}/* for(j) */
 } /* for(i) */

 for(j=1; j<argc; j++)
	for(i=0; i<pmsCnt; i++)
		if( (memstr(argv[j], 0,paras[i], 0, 3)) ){
			if(i<pmsCnt-1){
				if(msg_memstr==0)continue;
				parasVal[i]=1;
				}
			else if( (filters=strchr(argv[j],'=')) )filters++;
			pmpos[pmIdx++]=j;
		}

 for(i=1; i<argc; i++)if(*argv[i]!='-'){
	if(argv[i]!=dstdir)
		if(stat(argv[i], &st)==0 && S_ISDIR(st.st_mode) ){
		dirsrc=argv[i];
		if(spfile)printf("Source dir is \"%s\", than specied file \"%s\" ignore\n", dirsrc, spfile);
		pmpos[pmIdx++]=i;
		break;
		}
	}

 if(pmIdx<argc-1)for(i=1; i<argc; i++){
	for(j=0; j<pmIdx&&pmpos[j]!=i; j++);
	if( j>=pmIdx && (dirsrc||spfile) &&parasVal[2]==0 )
		printf("** Warn ! \"%s\" is not use param\n", argv[i]);
	}

 if(dirsrc==NULL&&spfile==NULL){
	printf( "No source dir input\n" );
	if(parasVal[2]==0)printf(usageChs);
	if(parasVal[3]==0)return 0;
	}

   if(outfile){
	    posfile=catstr(outfile, ".pos", 0);
	    funfile=catstr(outfile, ".fun", 0);
	}
   else if(dstdir){
	    posfile=catstr(dstdir, posfile, '/');
	    funfile=catstr(dstdir, funfile, '/');
	}

    posfp=fopen(posfile,WB);
    if(posfp==NULL){
	perror( posfile );
	return 4;
	}
    funfp=fopen(funfile,WB);
    if(funfp==NULL){
	perror( funfile );
	return 5;
	}

   if(dirsrc||spfile){
	char *pt;
/*	signal(SIGSEGV, _handle); */
	vose=parasVal[0];
	pt=strchr(*argv,'/');
	if(pt){ _ProgPath=*argv; *pt=0; }
	doCvt(dirsrc ? dirsrc : spfile, filters, parasVal[1] );
	}
  fclose(funfp);
  fclose(posfp);
  if(fsp_num)printf("Count : %d, created =>\n  %s\n  %s\n", total_KW, funfile, posfile);

  printf("%d file(s) have C define !\n", fsp_num);
}
else printf(usageChs);
return 0;
}
