/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo), 2012
	Reserve all rights of this file
*/

#define	BOOL	
/* use gcc, not c++ */


#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#define	stricmp	strcasecmp
#define	DIV_CH		'/'

#include "readfile.c"
#include "../normal/memstr.c"
#include "nextlen.c"

const char memblkcmp[7]={10,13,32, 9, ',' , ';' };

inline char *numbcode(char *chs)
{
  char ch;
  int i;
  for(i=0;(ch=chs[i])>47&&ch<58||ch=='-'||ch=='+';i++);
  return chs+i;
}

void namext(char *buff, const char *name, const char *ext, const char *dst)
{
 char *ptr;
  if(dst){
	int L=strlen(dst);
	scopy(buff, dst);
	ptr=strrchr(name, DIV_CH);
	if(ptr){
		if(dst[L-1]=='/')L--;
		scopy(buff+L, ptr);
		}
	else {
		buff[L++]='/';
		scopy(buff+L, name);
		}
	}
  else scopy(buff,name);
  ptr=strrchr(buff,'.');
  if(ptr)scopy(ptr,ext);
  else strcat(buff,ext);
}

void PutInto(FILE *fout,char *fmt, char *endchs, char *buf,unsigned  len)
{
fwrite(fmt,strlen(fmt),1,fout);
fwrite(buf, len,1,fout);
fwrite(endchs, strlen(endchs),1,fout);
}

#define FmtMultSyb(chr) (chr==32||chr==9? ',':chr)

static const char *pms_mode[2]={ "--pure", "--define" }, *vext[3]={ ".sor", ".val", NULL },*dext[3]={ ".csc", ".chr", ".def" },
usageChs[]="Usage : div [filename] |[--pure |--define] |-d [target-dir]\n\
\tFreely txt-mode,  Div-symbol(4):  [SPACE] [Tab] [Enter] , ;\n\
\t\"--pure\" out 2 pure text file as chars(*.chr), vals(*.val)\n\
\t\"--define\" create a C/C++ precompile file(*.def)\n\
\totherwise out 2 files, one is fsplus-script(*.csc), one is sort(*.sor) which temp\n\
\t\"-d\" is specied dir for out\n";

int main(int n,char **pm)
{
if(n>1){
 unsigned int len;
 int i, j, b, c=0, m=0, FreeOff, vlen=2, chrlen=0, t1, d_len, msg=0, pmpos[n-1];
 FILE *fchr, *fval;
 static char WT[]="wt";
 char *p_d, *valbuf, *chrbuf, *pt,  chr, *buffers, *pRt,
 fVal[200], pCxb[200];
 struct stat st;
 const char  *dstdir=NULL, *src=NULL;
 for(i=0; i<n-1; i++)pmpos[i]=-1;
 for(i=0; i<2; i++)
     for(j=1; j<n; j++)if(stricmp(pms_mode[i],pm[j])==0){
	if(m&&m!=i+1){
		printf("%s can't use with %s\n", pms_mode[i], pms_mode[m-1]);
		return -1;
		}
	m=i+1;	b=j; //pos
	pmpos[c++]=j;
	}

 for(i=1; i<n; i++)if(stricmp("-d", pm[i])==0){
	if(b==i+1 || i+1>=n ){
		if(dstdir==NULL){
			printf("A dir must follow \"-d\" for out !\n");
			pmpos[c++]=i;
		}
		continue;
		}
	if(stat(pm[i+1], &st) || !S_ISDIR(st.st_mode) )printf("\"-d\" specied \"%s\" is not existed dir !\n", pm[i+1]);
	else if(dstdir)printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, pm[i+1]);
	         else dstdir=pm[i+1];
	pmpos[c++]=i;		pmpos[c++]=++i;
	}

 for(i=1; i<n; i++)if(*pm[i]!='-'){
	if(pm[i]!=dstdir)
		if(stat(pm[i], &st)==0 && !S_ISDIR(st.st_mode) ){
		src=pm[i];
		pmpos[c++]=i;
		break;
		}
	}

 if(c<n-1)for(i=1; i<n; i++){
	for(j=0; j<c&&pmpos[j]!=i; j++);
	if(j>=c)printf("** Warn ! \"%s\" is not use param\n", pm[i]);
	}

 if(src==NULL){ printf("No source file input\n"); goto errpm; }

 p_d=strchr(*pm,DIV_CH);
 if(p_d){	*p_d=0;
	_ProgPath=*pm;
	}
 buffers=ReadFile(src,&len);
 if(buffers){
   namext(pCxb, src, dext[m], dstdir );
   fchr=fopen(pCxb,WT);
   if(fchr==NULL){
	perror(pCxb);
	return -1;
	}
   if(m<2){
	namext(fVal, src, vext[m], dstdir);
	fval=fopen(fVal,WT);
	if(fval==NULL){
		perror(fVal);
		return -1;
		}
	}
   else {
	fwrite("/*\n\tCreate by div, for fsplus devel\n\t", 37, 1, fchr);
	time_t tm;
	time(&tm);
//	p_d=asctime(localtime(&tm));
	p_d=ctime(&tm);
	fwrite(p_d, strlen(p_d), 1, fchr);
	fwrite("*/\n\n#ifndef\tFSP_commands\n#define\tFSP_commands\n\n", 47,1, fchr);
	}
/*===============================================*/
    len=strlen(buffers)+1;
    chrbuf=(char *)malloc(len*2+12);
    valbuf=chrbuf+len+4;
    while(*buffers==32||*buffers==9)buffers++;
    pt=buffers;
    for(i=0,b=0;i<len;i++){ chr=buffers[i];
           if(strchr(memblkcmp,chr)){
	FreeOff=ToNextLen(pt);
	pt+=FreeOff;
	p_d=numbcode(pt);
	t1=p_d-pt;
	d_len= i-(b+FreeOff) -t1;
	if(pt[0]=='/'&&pt[1]=='/'){ /* ignore(skip) // .... */
		c=i;
		for(j=0; pt[j]!='\n'&&/*pt[j]!='\r'&&*/pt[j]; j++)if(pt+j>buffers+c)i++;
		while(pt[j]=='\n'/*||pt[j]=='\r'*/){ j++; i++; }
		goto _skp_;
		}
	if(pt!=buffers){
	    pRt=memstr(buffers,b, p_d, d_len, 3);
	    if(pRt && (pRt[-1]>='0'&&pRt[-1]<='9') && strchr(memblkcmp, pRt[d_len]) ){
		p_d[d_len]=0;
		printf("mult define : %s\n ** fail !\n", p_d);
		return -1;		
		}
	    pRt=memstr(buffers,b, pt, t1, 3);
	    if(pRt && strchr(memblkcmp, pRt[-1]) && (pRt[t1]<'0' || pRt[t1]>'9') ){
		char c2=p_d[d_len];
		p_d[d_len]=0;
		printf("*** Warn ***\nmult set value : %s\n", pt);
		p_d[d_len]=c2;
		}
	}
	if(msg){
		msg=0;
		if(m==2){
			fwrite("#define  FSP_", 13, 1, fchr);
			fwrite(p_d, d_len, 1, fchr);
			char bu[t1+4];
			bu[0]='\t';	bu[1]='\t';
			for(j=0; j<t1; j++)bu[j+2]=pt[j];
			bu[t1+2]='\n';
			fwrite(bu, t1+3, 1, fchr);
		}
		else {
			for(j=0; j<d_len; j++)chrbuf[chrlen++]=p_d[j];
			chrbuf[chrlen++]=FmtMultSyb(chr);  /* fmt SPACE & Tab to ',' */
			for(j=0;j<t1;j++)valbuf[vlen++]=pt[j];
			valbuf[vlen++]=FmtMultSyb(chr);
			}
		}
	  else if(m<2){
		chrbuf[chrlen-1]=FmtMultSyb(chr);
		valbuf[vlen-1]=FmtMultSyb(chr);
//		if(m==2)
		}
	_skp_: b=i+1;	pt=buffers+b;
    	}
       else msg=1;
    }

    if(m<2){
	valbuf[0]=10; valbuf[1]=10;
	switch(m){
	case 1 :	for(i=0;i<chrlen-1;i++)if(strchr(memblkcmp,chrbuf[i]))chrbuf[i]=',';
		PutInto(fchr, "comchs=\"", "\";\n", chrbuf, chrlen-1);
		for(i=2;i<vlen-3; i++)if('\n'==valbuf[i])valbuf[i]=',';
		PutInto(fval, "const _Int vals[]={", " };\n", valbuf+2, vlen-3);
		break;
	case 0 : 	PutInto(fchr,"numbset 0 -t=t\n{\n", "\n}\n\n", chrbuf,chrlen-1 );
		PutInto(fchr,"numbset 1 -t=s\n{", "\n}", valbuf+1, vlen-2 );

		fwrite(chrbuf,chrlen-1,1,fval);
		fwrite(valbuf,vlen-1,1,fval);
		}
	fclose(fval);
/*    free(chrbuf); redure code */
	printf("Div created :\n  \"%s\"\n  \"%s\"\n",fVal,pCxb);
    }
    else {
	printf("Div created :   \"%s\"\n",pCxb);
	fwrite("\n#endif\n", 8, 1, fchr);
	}
    fclose(fchr);
    return 0; /* for make.exe */
    }
    printf("\n");
//   else return 1; // printf("fail to read %s\n", pm[1]);
/* Null */
 }
else errpm: printf(usageChs);
return -1; /* for make.exe */
}
