/*
	Write & edit by LinJiangHua(xempo)
	Free under LGPL
*/

#ifndef  STD_BASE
#define  STD_BASE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "envpath.h"

extern const char homestr[];
extern FILE *fopen64 (__const char *__restrict __filename,
		      __const char *__restrict __modes) __wur;

__BEGIN_DECLS
extern void *fspX;
extern int (*msgShow)(const char *txt);
extern void (*getMsg)(const char *buf);
extern int (*popMsg)(const char *,const char *, int fg, void *p);
extern void (*PrnTxt)(int x, int attrib, const char *buf);

extern void scopy(char *s, const char *d); /* catstr.c */
extern char *catstr(const char *pth,const char *fnam, char chr);

extern const char *accepath(const char *fname, int mode, StrList *lst);
extern FILE *pathopen(const char *fnam, int m, const char **rc, StrList *lst);

extern int msg_memstr;
extern char *memstr(const char *sc,unsigned int ln,const char *in,unsigned int ln2,int msg);
/*  msg:
0 bit: setbit is first string; else  is last string
1 bit: setbit is use case; else is no case
7 bit: TongPan
return msg_memstr!=0  sc==in
*/

extern unsigned int fmtinp(char *Inp,int *ret,const char *fmt,char ch);

extern char **setargv(char *src, const char *fmt, int *rt);

extern int fmtvalue(char *val, int pure);
/* pure=True, remove string \"  */

extern char *strchrs(const char *src,const char *chrs);

extern char *ReadFile(const char *fname,unsigned int *filelen, int txtmsg, void *X, StrList *lst);
__END_DECLS

#define int_type_count  4
#define int_style_count 3

extern const char TypeStr[17][6];
extern const char *getints(const char *pt, int *type);

#endif
