/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011, 2012
  Free under LGPL
*/

// #include "fspdir.h"
#include "dirloop.h"
#include "fcu.h"
#include "infor.h"
#include "dlist.h"
#include "options.h"
#include "stdfun.h"

static const char *chkbuff;
static int BrowCnt;
static int  CurDirPrn;

inline int NumbFind(fsp_dir *dir,BYTE *xstat)
{
  MAU mau;
  int cntdir=(nGetFCU(dir))->FCU_Count,
	n=dir->DAUC, i, j;
  BOOL 	zero=isZero(dir->Format);
  for(i=0;i<cntdir;i++){
    if(*xstat==1 && (xstat[1]&FSP_OEM)==0 ){
      for(j=0;j<n;j++)
	if(readDAU(dir, xstat, &mau, j)&&
	memstr(mau.buf,mau.len,chkbuff,0,1)){
		if(CurDirPrn<1){
			if(CurDirPrn==0){
				char *dirnam=pdPathNam(dir,dst_dir/*not dircmp*/,1), buf[1048];
				sprintf(buf, "Sub dir : %s", dirnam);
				msgShow(buf);
				free(dirnam);
				}
			CurDirPrn=1;
		}
		BrowCnt++;
		showFCU(dir, xstat, True); /* fixStatNum(...) NumbForZero++ , so goto _skp_*/
		goto _skp_;
		}
      }
    if(zero)dir->NumbForZero++;
    _skp_: xstat+=dir->Num_FCU_Len;
    }
  return 1;
}

inline int pdFind(fsp_dir *dircmp,fsp_dir *dir)
{
  CurDirPrn=0;
  return 1;
}

void Find(fsp_dir *dir, int n,char **pm)
{
 int a, msg,
	brwVal[BrowsModeCnt];
 arglists *lst;
// fsp_lib *lib=dir->lib;
#define  mu2  1
 int rt=0; // mu2val[mu2];
 static const char *mu2key[mu2]={ "-K" },*_mu2key[mu2]={ "--key" };
 memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
// memset(mu2val, 0, sizeof(int)*mu2);
 ProcOpt optBrows={
	BrowsModeCnt,
	browsMode, _browsMode,
	brwVal,
	0,
	NULL
	},
  opt2={
	mu2,
	mu2key, _mu2key,
	&rt,
	0,
	NULL
	};
  if( !(lst=procParas(n, pm, &optBrows, &opt2)) )return;
  rt&=0x7fff;
  if(rt==0){
	fspHB(21,True);     showUsage(FSP_find);
	goto _exit_;
	}
  chkbuff=lst->subarg->argv[0];
  msg=getBM(brwVal);
  a=0;
  if(lst->argc==0){
	dst_dir=DirOpen(dir,NULL);
	goto _jmp_;
	}
  while( a<lst->argc ){
    dst_dir=DirOpen(dir, lst->argv[a]);
    if(idxdscpt>0x7ffd){
_jmp_:      BrowCnt=0;
      if( (msg&3)==0)msg=1;
      CurDirPrn=-1;
      DirFullBrow(dst_dir,msg,NumbFind,pdFind);
      if(getMsg){
	char buf[128];
	sprintf(buf, "  Total found <font color=#203090><u> %d </u></font>",BrowCnt);
	}
      else printf("  Total found \033[7m %d \033[0m\n",BrowCnt);
//      if(isNormDir(dst_dir) && dst_dir!=lib->CurDir)free(dst_dir);
       pd_close(dst_dir, 1);
    }
    else reportBug();
    a++;
  }
_exit_: argsFree(lst);
}

