/*
	Write & edit by Linjianghua(xempo)
	Free under LGPL
*/

#define	stricmp	strcasecmp

#define	_Tag	0xfffffff
#define	BOOL 	
#define	True	1
#define	False	0

#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <stdlib.h>
#include "memstr.c"
#include "strchrs.c"
#include "fmtvalue.c"
#include "delete.c"
#include "fmtinp.c"
#include "setargv.c"

#include "nextlen.c"
#include "readfile.c"
#include "filter.c"

char *fixptr(char *pt)
{
while(*pt=='\n')pt++;
return pt;
}

static const char operaChs[]="operator",
DEF[]="define", *def[]={DEF,"undef", "ifdef", "ifndef"};
int bepure(char *txt)
{
int i=0, j, t, L;
while( txt[i] ){
  switch(txt[i]){
  case '/' : if(txt[i+1]=='/'){
	j=i+2;
	_del_:	while( txt[j]!='\n'&&txt[j]!=0)j++;
		Delete(txt+i, j-i);
	}
	break;
  case '#' : if(i==0||txt[i-1]==10){
	for(j=i+1; txt[j]==32; j++);
	for(t=0; t<4; t++){
	    L=strlen(def[t]);
	    if(memcmp(def[t], txt+j, L)==0&&txt[j+L]==32)goto _out_;
	}
	goto _del_;
	}
	}
_out_: i++;
  }
return i;
}

int bepure2(char *txt)
{
int i, j, len, zxpos=-1, yhpos=-1,
	zxcn=0, yhcn=0;
for(i=0; txt[i]; i++){
  if(zxpos>-1){
	if(txt[i]=='\n' )zxcn++;
	}
  else if(txt[i]=='\"'){
	if(yhpos>-1){
		len=i+1-yhpos;
		Delete(txt+yhpos,len-yhcn);
		for(j=0; j<yhcn; j++)txt[yhpos+j]='\n';
		i-=len-yhcn;
		yhcn=0;	yhpos=-1;
		}
	else {
		yhpos=i;
		continue;
		}
	}
  if(yhpos>-1){
	if(txt[i]=='\n' )yhcn++;
	}
  else  if(txt[i]=='/'&&txt[i+1]=='*')zxpos=i;
  if(txt[i]=='*'&&txt[i+1]=='/'){
	len=i+2-zxpos;
	Delete(txt+zxpos,len-zxcn);
	for(j=0; j<zxcn; j++)txt[zxpos+j]='\n';
	i-=len-zxcn;
	zxcn=0;	zxpos=-1;
	}
  }
return i;
}

/* #define backManLook(pt, c)		while( pt[c]==32||pt[c]=='\n' )c--;
#define forwardManLook(pt, y)	while(pt[y]==32||pt[y]=='\n')y++;
BOOL keywordCmp(char *pt, int i, const char *kw1, const char *kw2)
{
while(i>0 && (pt[i]==32 || pt[i]==10))i--;
while(i>0 && pt[i]!=32 && pt[i]!=10)i--;
if(memcmp(pt+i+1, kw2, strlen(kw2))==0){
	int s=strlen(kw1);
	while(i>0 && (pt[i]==32 || pt[i]==10))i--;
	if(memcmp(pt+i-s+1, kw1, s)==0)return False;
	}
return True;
}*/

#define	TypeCount		6
int keyword, fsp_num, *Index, fcnt, vose;
FILE *posfp, *funfp;
static const char WT[]="wt", tmplate[]="template",
*__TypeChs[TypeCount]={ tmplate, "enum",  "class", "struct", "union", "typedef" };

char *pHd, *srcNam;

void handle(int num)
{
printf("内存错误，程序将非正常退出。\ntotal : %d , error in %s,%d,%d\n" , keyword, srcNam, fcnt, *Index);
exit(20);
}

const char *isKeyword(const char *txt, int len, const char *key)
{
const char *ptr;
int L;
return ( (ptr=memstr(txt, len, key, L=strlen(key), 3))!=NULL &&
		(ptr[-1]==10||ptr[-1]==32||ptr==txt) &&
		(ptr[L]==10||ptr[L]==32||ptr[L]=='<') ) ? ptr : NULL;
}

BOOL dwrite(const char *txt, int len, int pos)
{
if(memstr(txt, len, operaChs, sizeof(operaChs)-1, 3)==NULL){
	fprintf(posfp, fcnt ? ",%d" : "%d", pos);
	if(fcnt++>0)fwrite(":", 1, 1, funfp);
	fwrite(txt, len, 1, funfp);
	return True;
	}
return False;
}

int doCvt(const char *dirsrc, const char *filters, int msg)
{
  char *pt, *ptr, *str, *buf;
  int  len, spfile, space, __type=0,
	flen,  y,  unitBegin, j, i, n, _line, cn,
	pos_idx, fun_idx;
  struct stat st;
  struct dirent *dstru;
  Index=&cn;
  if(stat(dirsrc, &st)){
	perror(dirsrc);
	return -1;
	}
  spfile=!S_ISDIR(st.st_mode);
  if(spfile){ srcNam=(char *)dirsrc; goto _done_; }
  DIR *dir=opendir(dirsrc);
  if(dir==NULL){
	perror(dirsrc);
	return -1;
	}
  len=strlen(dirsrc);
  srcNam=(char *)malloc(len+258);
  scopy(srcNam, dirsrc);
  if(srcNam[len-1]!='/')srcNam[len++]='/';
  while(spfile==0 && (dstru=readdir(dir)) ){
    ptr=dstru->d_name;
    if((ptr[0]=='.' && (ptr[1]==0 || ptr[1]=='.'&&ptr[2]==0 )) )continue;
    scopy(srcNam+len, ptr);
    stat(srcNam, &st);
    if(S_ISDIR(st.st_mode)){
	if(msg&1)doCvt(srcNam, filters, 1);
	}
    else {
	if( namefilters(ptr, filters, 3)==0 )continue;
//________________________________________________________
_done_:	if( !(buf=ReadFile(srcNam, &flen)) )return 3;
	if(spfile==0&&vose)printf("%s ...\n", srcNam);
	bepure(buf);
	flen=bepure2(buf);
	pt=buf;
	for(i=flen-1;i>0&&(pt[i]==10);i--,flen--)pt[i]=0;

  char buff1[1200], buff2[40];
  pos_idx=ftell(posfp);	fun_idx=ftell(funfp);
  sprintf(buff1, "numbset %d -t=vi\n{\n%s\n}\n{\n", fsp_num, srcNam);
  fseek(posfp, pos_idx+strlen(buff1), 0);
  sprintf(buff2, "write.m: %d ", fsp_num);
  fseek(funfp, fun_idx+strlen(buff2), 0);
  fcnt=0;	cn=0;
  unitBegin=0; i=0;
  space=0;
  int B, d, syb, T, L, __syb;
  while(i<flen){
	switch(pt[i]){
	case '\n' : cn++;
		break;
	case ';' : { // baseUnit
		while(pt[unitBegin]==10||pt[unitBegin]==32)unitBegin++;
		j=unitBegin;
_loop0_:	while(pt[j]!=',' &&pt[j]!='('&&pt[j]!='='&&j<i)j++;
		B=j-1;
		while(pt[B]==32||pt[B]==10)B--;
		if(pt[B]==']'){ // [xx]
			while(pt[--B]!='[');
			d=B;
			}
		else d=B+1; // Name end
//		if(space!=':'&&space!='='){
		if(pt[j]=='('){
		      y=j;
		      while(pt[++y]==32||pt[y]==10);
		      if(pt[y]=='*'){
			while(pt[++y]==32||pt[y]==10);
			n=y;
			while(pt[++y]!=')');
			j=y;
			while(pt[--y]==32||pt[y]==10);
			//pt[y]=0;
			dwrite(pt+n, y+1-n, cn);
			goto _through_syb2;
			}
		}
		while(B>=unitBegin&&(pt[B]!=32&&pt[B]!=10&&pt[B]!='*'&&pt[B]!=','))B--; // Name begin
//		  space=pt[j];
//		  pt[d]=0;
		if(dwrite(pt+B+1, d-(B+1), cn)==False){
			unitBegin=i+1; // space=0;
			goto _Loop_;
			}
//		}
//		else space=0;
		switch(pt[j]){
		case '('  : 
		_through_syb2:      syb=1;
		      while(++j<i){
			switch(pt[j]){
			case '(' : syb++;
				break;
			case ')' : if(--syb==0){
					while(pt[j]!=',' &&j<i)j++;
					goto _jmp2_;
					}
				}
		      }
			break;
		case ':' :
//			break;
		case '=' : while(++j<i && pt[j]!=',' && pt[j]!='(' && pt[j] != '=' );
		}
_jmp2_:		unitBegin=++j;
		if(j<i)goto _loop0_;
		else unitBegin=i+1;
		}
		break;
	case '#' : for(n=i+1; pt[n]==32; n++);
		if( (i==0||pt[i-1]==10) && memstr(pt+n,6, DEF, 6, 3)==pt+n){
		  for(n+=6; pt[n]==32; n++);
		  B=n;
		  while(pt[n]!=32&&pt[n]!='('&&n<flen){
			if(pt[n]==10){ cn++; break; }
			n++;
			}
		  d=n;
//		  pt[d]=0;
		  if(pt[n]=='('){
		      syb=1;
		      while(++n<flen){
			switch(pt[n]){
			case '(' : syb++; break;
			case 10 : cn++; break;
			case ')' : if(--syb==0)goto _jmp3_;
			}
		      }
		  }
_jmp3_:		  dwrite(pt+B, d-B, pt[n]==10 ? cn-1 : cn);
		  while( ++n<flen )
		      if( 10==pt[n]){
			cn++;
			for(j=n-1;j>0&&(pt[j]==32);j--);
			if(pt[j]!='\\')goto _brk_;
			}
		} // end if
	_brk_:	i=n;	unitBegin=i+1;
		break;
	case '{' : syb=1; pt[i]=32;
		__type=0;	_line=0;
		__syb=0;
		for(T=0; T<TypeCount; T++)
		  if( isKeyword(pt+unitBegin, i-unitBegin, __TypeChs[T]) ){
			__type=T+1;
			break;
			}
		switch(__type){
		case 1 : for(n=unitBegin; pt[n]!='>'; n++){
				if(pt[n]==10)cn++;
				} // template string
			n++;
			while(pt[n]==10||pt[n]==32){
				if(pt[n]==10)cn++;
				n++;
				}
			while(pt[n]!=32){
				if(pt[n]==10){cn++; break; }
				n++;
				}
//-----------------------------------------------------------------------------------------------------
			while(pt[n]==10||pt[n]==32){
				if(pt[n]==10)cn++;
				n++;
				}
			for(j=n; pt[j]!=32&&pt[j]!='('; j++)
				if(pt[j]==10){ cn++; break; }
			if(memstr(pt+n, j-n, operaChs, 8, 3)!=pt+n)dwrite(pt+n, j-n, cn); // write 2nd
			for(n=i+1 ; n<flen; n++)
			  switch(pt[n]){
			  case '{' : syb++;
			/*	if( (ptr=(char *)isKeyword(pt+i, n-i, "explicit")) ){
					for(d=8; ptr[d]==10||ptr[d]==32; d++)
						if(ptr[d]==10)cn++;
					for(j=d; ptr[j]!=32&&ptr[j]!='('; j++)
						if(ptr[j]==10){cn++; break; }
					dwrite(ptr+d, j-d, cn);
					}*/
				break;
			  case 10 : cn++; break;
			  case '}' : if(--syb==0){
					while(pt[++n]==32||pt[n]==10);
					while( pt[n]!=';'&& n<i ) n++;
					i=n+1;
					unitBegin=n;
					goto _Loop_;
				}
			  }
			break;
		case 3 : if( (ptr=memstr(pt+unitBegin, i-unitBegin, ":", 1, 1))!=NULL){
				__syb=0xff;
				while( *(--ptr)==32 ||*ptr==10)if(*ptr==10)_line--;
				d=0;
				while( *(ptr--) != 32 ){
					if(*ptr==10){ _line--; break; }
					d++;
					}
				dwrite(ptr+1, d+1, cn+_line);
				}
			break;
		case 0 :	n=i;
			while(pt[--n]!=')'&&n>unitBegin);
			if(pt[n]==')'){ // is inline
				int k=1;	_line=0;
				while(n>unitBegin)
				switch(pt[--n]){
				case ')' : k++;
					break;
				case 10 : _line++;
					break;
				case '(' : if(--k==0){
					while(pt[--n]==32||pt[n]==10)if(pt[n]==10)cn--;
					j=n;
					while(pt[--n]!=32 && pt[n]!=10&&pt[n]!='*'&&pt[n]!='&');
					dwrite(pt+n+1, j-n, cn-_line);
					for(n=i+1 ; n<flen; n++)
					switch(pt[n]){
					case '{' : syb++;
						break;
					case '}' : if(--syb==0){
						i=n;	goto _jmp_;
						}
					}
				}
				}
			}
		}
_jump_:		for(n=i+1 ; n<flen; n++)
		switch(pt[n]){
		case '{' : syb++;
			break;
		case ':' : if(__type==3){ // like  public: or private :
		//		if( isClassKeyword(pt+n) )
				pt[n]=32;
				}
			else pt[n]='=';
			break;
		case 10 : _line++;
			break;
		case '}' : if(--syb==0){
			int I;
			pt[n]=32;
			if(__type==0){
//				i=n;
				goto _jmp_;
				}
			I=n;
			while(pt[++n]==32||pt[n]==10)if(pt[n]==10)_line++;
			for(j=n; pt[j]!=';'&&j<flen; j++);
			if(__type!=2)pt[j]=32; // enum reserve ';'
			if(__syb>0xf0)goto _jmp_;
			for(B=j-1; I!=B&&(pt[B]==32||pt[B]==10); B--);
			j=B+1;
			while(pt[B]!=32&& pt[B]!=10&&pt[B]!='*'&&I!=B)
			//	if(pt[B]==10){ _line--; break; }
				B--;
				
			if(j-B-1>0)dwrite(pt+B+1, j-B-1, cn+_line);
			else { // goto head
				for(n=i-1; pt[n]==32||pt[n]==10; n--);
				for(d=n++; pt[d]!=32&&pt[d]!=10; d--);
				//pt[n]=0;
				dwrite(pt+d+1, n-d-1, cn);
			}
			_jmp_: unitBegin=i+1; goto _Loop_;
			}
		}
	}
_Loop_:   i++;
  }
  if(fcnt){
	fprintf(funfp,"\n\n");
	fprintf(posfp,"\n}\n\n");

	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);

	fprintf(posfp, buff1);
	fprintf(funfp, buff2);
	fseek(posfp, 0, 2);
	fseek(funfp, 0, 2);
	fsp_num++;
	if(spfile==0&&vose)printf("    have %d\n", fcnt);
	keyword+=fcnt;
	}
  else {
	fseek(funfp, fun_idx, 0);
	fseek(posfp, pos_idx, 0);
	}
  }
  }
  if(spfile==0)closedir(dir);
return 0; // success
}

#define	dstdir	dyVar[0]
#define	spfile	dyVar[1]
#define	outfile	dyVar[2]
#define  varsCnt	3
#define  pmsCnt	4
int main(int cnpm,char **pms)
{
static const char usageChs[]="Cvt C head file for runtime-help\n\
Usage : mkhlp [Dir|-f sourcefile] | [-d dir|-o outfile] | [--filters=xxx]\n\
      [--vose]|[--test]|[--sub]|\n\
      --vose : show message\n\
      --sub : include subdir\n\
      default create \"helpfun.fss\" & \"helppos.fss\"\n";

if(cnpm>1){
  static const char *parms[pmsCnt]={ "--vose" , "--sub", "--test", "--filters=" }, // save sw[]
	*vars[varsCnt]={"-d" , "-f", "-o"},
	*lostdst[3]={"A dir must follow \"%s\" for out !\n",
		"A file must follow \"%s\" as source !\n",
		"A file must follow \"%s\" as outfile !\n",
	},
	*warnMult[3]={"Out dir has specied \"%s\", \"%s\" not be use !\n",
		"Source file specied \"%s\", \"%s\" not be use !\n",
		"Out file has specied \"%s\", \"%s\" not be use !\n"
	};
  char *pt,  sw[3]={0,0,0};  // => parms index
  struct stat st; 
  int c, pmpos[cnpm-1],   j,  i;
  const char  *dyVar[varsCnt],  *dirsrc=NULL, *filters=NULL,
 *funfile="helpfun.fss", *posfile="helppos.fss"; // default create 2 files
 memset(dyVar, 0, varsCnt*sizeof(char *));
 for(i=0; i<cnpm-1; i++)pmpos[i]=-1;
 c=0;
 for(i=1; i<cnpm; i++){
      for(j=0; j<varsCnt; j++)if(stricmp(vars[j], pms[i])==0){
	if( i+1>=cnpm ){
		if(dyVar[j]==NULL){
			printf(lostdst[j], vars[j]);
			pmpos[c++]=i;
		}
		continue;
		}
	pmpos[c++]=i++;
	switch(j){
	case 0 :	if(stat(pms[i], &st) || !S_ISDIR(st.st_mode) ){
			printf("\"-d\" specied \"%s\" is not existed dir !\n", pms[i]);
			goto _jmp_;
			}
		break;
	case 1 :	if(stat(pms[i], &st) || S_ISDIR(st.st_mode) ){
			printf("\"-f\" specied \"%s\" is not existed file !\n", pms[i]);
			goto _jmp_;
			}
//		break;
	}
	if(dyVar[j])printf(warnMult[j], dyVar[j], pms[i]);
	else dyVar[j]=pms[i];
	_jmp_: pmpos[c++]=i;
	break;
	}
 }

 for(j=1; j<cnpm; j++)
	for(i=0; i<pmsCnt; i++)
		if(pt=memstr(pms[j], 0,parms[i], 0, 3)){
			if(i<pmsCnt-1){
				if(msg_memstr==0)continue;
				sw[i]=1;
				}
			else if( filters=strchr(pms[j],'=') )filters++;
			pmpos[c++]=j;
		}

 for(i=1; i<cnpm; i++)if(*pms[i]!='-'){
	if(pms[i]!=dstdir)
		if(stat(pms[i], &st)==0 && S_ISDIR(st.st_mode) ){
		dirsrc=pms[i];
		if(spfile)printf("Source dir is \"%s\", than specied file \"%s\" ignore\n", dirsrc, spfile);
		pmpos[c++]=i;
		break;
		}
	}

 if(c<cnpm-1)for(i=1; i<cnpm; i++){
	for(j=0; j<c&&pmpos[j]!=i; j++);
	if(j>=c)printf("** Warn ! \"%s\" is not use param\n", pms[i]);
	}

 if(dirsrc==NULL&&spfile==NULL){ printf("No source dir input\n"); goto _msg_; }

  c=(sw[2]<<1);
  if(c==0){
	if(outfile){
	    posfile=catstr(outfile, ".pos", 0);
	    funfile=catstr(outfile, ".fun", 0);
	}
	else if(dstdir){
	    posfile=catstr(dstdir, posfile, '/');
	    funfile=catstr(dstdir, funfile, '/');
	}

	posfp=fopen(posfile,WT);
	if(posfp==NULL){
	    perror( posfile );
	    return 4;
	}
	funfp=fopen(funfile,WT);
	if(funfp==NULL){
	    perror( funfile );
	    return 5;
	}
  }
//  struct sigaction sig;
  signal(SIGSEGV, handle);
  vose=sw[0];
  pt=strchr(*pms,'/');
  if(pt){ _ProgPath=*pms; *pt=0; }
//  if(filters)printf("%s\n", filters);
  doCvt(dirsrc ? dirsrc : spfile, filters, sw[1]|c );
  if(c==0){
	fclose(funfp);
	fclose(posfp);
	printf("Count : %d, created =>\n  %s\n  %s\n", keyword, funfile, posfile);
	}
  printf("%d file(s) have C define !\n", fsp_num);
//	}
}
else _msg_:printf(usageChs);
return 0;
}
