/*
	Write by LinJuangHua(xempo) 12-2013
	Copyright LinJiangHua 2013
	Free under LGPL
*/

#ifndef	_Simple_Edit_
#define	_Simple_Edit_

#include "editor.h"
#include "highlight.h"
#include "helpwdg.h"

typedef  int  file_pos[4];

#define  PRO_FSP_WRITE  -3

extern file_pos	*menuFilesPos, *menuWdgsSiz;

extern char *menuIsMaxs;  // one : isMax, other : _codec

extern int mdfCount;
class QAction;
class QLabel;
class Filesan;

extern QTextCodec * _setCodec(int code);

class ProEdit : public QMainWindow
{
 moc_Object
//    Q_OBJECT
public :
ProEdit(Filesan *, const char *, int num);
//~ProEdit();
int exec(int pos=0, const char *fun=NULL);

void setTitle();

void setFnt(const QString &fn, const char *sz, bool bold, bool italic, bool underline);

const QPixmap *docIcon;

const char *getFileName()
{ return fileNam; }

const char *getPath()
{ return selfpath; }

bool getModified() // const 
	{ return Modified; }

int getNumb() const
	{ return numb; }

Editor *editor(){ return edt; }

void getHelp(const char *fun, bool nx, bool blur);

void backup()
{
if( Modified && ++baktm/120 > pms_baktm )save(-1 /* backup */);
}

QTextCodec *curCodec()
{
return _setCodec(_codec);
}

void setFspDir(fsp_dir *dir){ pCwd=dir; }

void showMessage(const char *); // inline filesan.cc

Filesan *getFilesor() const
{ return filesor; }

protected:
bool event( QEvent *e);

private:
char *selfpath;
int *_Params;
void showCursor(int p, int i);
void notModified(bool);
bool save(int fresh, int savecode=-1); // fresh : -1 backup, 0 not fresh,  1 save&fresh
int fspWrite();
bool trySave(int fresh);

// void setFontMemb(int sw, const QString &s);

int findMode, numb,  // in event(), can use pe->numb
	_codec, baktm, popVal,
	tmId, tms, /* isMin wdg showNormal, and raise & active */
	csid[cs_modul_cnt];

void createCStyleMenu(const char *txt, int n);

struct stat64 mdfst;
StatusPanel *sbar;
QPopupMenu *cstyle;
QLabel *cursorPos;
Editor *edt;
Filesan *filesor;
fsp_dir *pCwd;
QAction *saveAct, *saveAllAct, *closeAllAct,
	*confAct,
	*findAct, *findNextAct, *findBackAct;
//	*boldAct, *italicAct, *underlineAct;
const char *fileNam;
bool findResult, Modified, undo_Avai, isMax,
	enCodeced;// disable editChange
};

extern QPtrList <ProEdit> proEditList;

extern const char slot_save[], slot_popCodecMenu[];

extern const QMetaData codecSlot, popCodecMenuSlot, asDCSlot, saveSlot,
	clippathSlot, PZpathSlot;

extern int hlpnum;

extern void setTextEdit(QTextEdit *edt, char *buf, unsigned int Len, int code);

#endif

