/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of file
*/

#define	stricmp	strcasecmp
#include <unistd.h>
#include <sys/stat.h>
#include "readfile.c"
#include "nextlen.c"
#include "../normal/memstr.c"

const char memblkcmp[]={10,32, 9, ',' , ';' , 0};

int main(int argc,char **pm)
{
static const char usageChs[]="Usage : hbsort [hbfile] [sortfile](index) |[--dvp]|[--case] |[-d outdir]\n\
\tspecied \"--dvp\" out pure text file, else out is fsplus-script\n\
\t--case means char of 2 file-data case\n\
\t\"-d\" is specied dir follow as out !\n\
\tFreely txt-mode, Div-symbol:  2[Enter]\n";

if(argc>1){
  FILE *fout;
  static const char *params[3]={ "--dvp", "--case", "-d" };
  const char *srcfile=NULL, *idxfile=NULL, *dstdir=NULL;
  char *idxbuf, **DScpt, *pt, *ptr, outfile[1024], buff[80];
  static char sw[3];
  unsigned int len, n, i, j, b, m,
	cmplen, wlen, cn, nxlen, nmb=0;
  struct stat st;
//  memset(sw,0,3);
  if(argc>3){
	for(i=1;i<argc;i++){
	  pt=pm[i];
	  for(j=0;j<3;j++)
		if(stricmp(pt,params[j])==0){
			if(j==2){
			if(i+1>=argc)goto _setShow_; // error will show after.
			if(stat(pm[i+1], &st)==0&&S_ISDIR(st.st_mode)){
				if(dstdir){
					printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, pm[i+1]);
					break;
				}
				dstdir=pm[++i];
				}
			else {
				printf("\"-d\" specied \"%s\" is not existed dir !\n", pm[i+1]);
				break;
				}
			}
			_setShow_:	sw[j]=1;
			break;
		}

	  if(j>2&&dstdir!=pt){
		if(srcfile==NULL){
			if(stat(pt, &st)==0&&!S_ISDIR(st.st_mode))srcfile=pt;
			}
		else if(idxfile==NULL){
			if(stat(pt, &st)==0&&!S_ISDIR(st.st_mode))idxfile=pt;
			}
		         else printf("%s is unuseful params\n", pt);
		}
	}
  }
  
  pt=strchr(*pm,'\\');
  if(pt){ _ProgPath=*pm; *pt=0; }

  if(idxfile==NULL){ printf("No index file !\n"); return -1; }
  if( !(idxbuf=ReadFile(idxfile, &len)) )return -1;

/*============= get descript(poors) ======================*/
 if( !(pt=ReadFile(srcfile,&cn))) return -1; 
 for(pt[cn]=0,i=cn-1;i>0&&pt[i]==10;i--,cn--)pt[i]=0;
 for(n=1,i=0;i<cn;i++)
	if(pt[i]==10 && pt[i+1]==10 ){
		n++; pt[i]=0;
		if(i<cn){
		  j=ToNextLen(pt+i+2);
		  if(j>0)i+=j-1;/* as i++ in loop */
		}
	}
 DScpt=(char **)malloc(n*sizeof(char *)+8);
 *DScpt=pt;
 for(j=1,i=0;i<cn&&j<n;i++)if(pt[i]==0){
	nxlen=ToNextLen(pt+i);
	DScpt[j++]=pt+i+nxlen;
/*	printf("nx=%d, %s",i+nxlen,DScpt[j-1]);*/
 }
/*============= get descript(poors) ======================*/
  if(sw[2]){
	if(dstdir){
		int L=strlen(dstdir);;
		scopy(outfile, dstdir);
		pt=strrchr(srcfile, '/');
		if(pt){
			if(dstdir[L-1]=='/')L--;
			scopy(outfile+L, pt);
		}
		else { outfile[L++]='/'; scopy(outfile+L, srcfile); }
		}
//		goto _skp_;
	else {
		printf("A dir must follow \"-d\" for out !\n");
		goto _setsrc_;
	}
	}
  else  _setsrc_: scopy(outfile, srcfile);
  pt=strrchr(outfile,'.');
  if(pt)scopy(pt,".out");
  fout=fopen(outfile,"wt");

  len++;
  for(cn=0,i=0,b=0;i<len&&cn<n;i++)
    if(strchr(memblkcmp,idxbuf[i])){
    pt=idxbuf+b;
    cmplen=i-b;
    idxbuf[i]=0; b=i+1;
    if(cmplen>0){
	for(j=0;j<n;j++){
	  ptr=DScpt[j];
	  if(ptr[cmplen]==':'&&memstr(ptr,cmplen,pt,cmplen,1|(sw[1]*2))){
	    wlen=strlen(ptr);	cn++;
	    ptr[wlen]='\n';	wlen++;
	/*    if(cn<n){ ptr[wlen]='\n'; wlen++; }*/
	    if(*sw/* "-dvp" */){
		while(*ptr!=10){
			ptr++;		wlen--;
			}
		wlen--;
		if(*ptr==10)ptr++;
	    }
	    sprintf(buff,"numbset %d -t=v  -l=%d\n{\n",nmb, wlen);
	    fwrite(buff,strlen(buff),1,fout);
	    fwrite(ptr,wlen,1,fout);
	    fwrite("}\n\n",3,1,fout);
	    break;
	   }
       }
      if(j>=n){ 
		sprintf(buff,"numbset %d -t=v\n{\n",nmb);
		fwrite(buff,strlen(buff),1,fout);
		fwrite(pt,cmplen,1,fout);
		fwrite(": ...\n}\n\n",9,1,fout);
		}
	nmb++;
	}
    else break;
  }
/*  free(idxbuf); redure code */
/* free(*DScpt);free(DScpt); */
  fclose(fout);
  printf("Create \"%s\" successfully\n",outfile);
  return 0; /* for make.exe */
}
printf(usageChs);
return 1;
}
