/*
	Write by xempo
	Free under GPL
*/

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>

#define  stricmp  strcasecmp
#define  DIV_CH  '/'

#define msgShow puts

void *zalloc(unsigned int sz)
{
void *pt;
memset((pt=malloc(sz)), 0, sz);
return pt;
}

static const char newsep[]="=", oldsep[]="=:";
const char *separaChs;

#include "../normal/catstr.c"
#include "options.c"

int main(int argc, char **argv)
{
if( argc > 1 ){
#define mu1  3
#define inv1  2
 static const char *mu1chs[mu1]={ "-P", "-D", "-T" }, *_mu1chs[mu1]={ "--pure", "--define", "--test" };
 int mu1val[mu1];
 static const int mu1inv[inv1]={ 0, 1 }; // "--pure", "--define" can't same use

#define  mu2  3
#define inv2  2
static const int mu2inv[inv2]={ 1, 2 };
int mu2val[mu2];
static const char *mu2chs[mu2]={"-w", "-d", "-o"},*_mu2chs[mu2]={ "--warn", "--dstdir", "--out" };
separaChs=oldsep;
 memset(mu1val, 0, sizeof(int)*mu1);
 memset(mu2val, 0, sizeof(int)*mu2);
 ProcOpt opt1={
	mu1,
	mu1chs, _mu1chs,
	mu1val, // not 0 is use
	inv1,
	mu1inv
	},
	opt2={
	mu2,
	mu2chs, _mu2chs,
	mu2val, // not 0 is use, and index of send-argv : (mu2val[i]&0x7fff)
	inv2,
	mu2inv
	};
  arglists *lst=procParas(argc-1, argv+1, &opt1, &opt2);

  int i;  
  if(lst)for(i=0;i<lst->argc;i++)printf("\"%s\" is opera-unit !\n", lst->argv[i]);
  else goto errpm;

  for(i=0; i<opt2.argc; i++)
     if( opt2.rtval[i] )
	switch(i){
	case 0 : printf(" ** Tips : %s\n", lst->subarg->argv[i]);
		break;
	case 1 : printf(" ** Out dir  : %s\n", lst->subarg->argv[i]);
		break;
	case 2 : printf(" ** Out file : %s\n", lst->subarg->argv[i]);
	}
//-------------------------------------------------------------------------
  return 0;
}
else {
static const char usageChs[]=
"Usage : testoptions [filename] |[--pure] |[--define] |[--test] |[-o mainfile] |[-d target-dir] |[-w tips]\
\n\t\"--pure,-P\"    out 2 pure text file as chars(*.chr), vals(*.val)\
\n\t\"--define,-D\"    create a C/C++ precompile file(*.def)\
\n\t\"--test,-T\"     test bug\
\n\t\"-o,--out\"     is specied out's file\
\n\totherwise out 2 files, one is fsplus-script(*.csc), one is sort(*.sor) which temp\
\n\t\"-w,--warn\"     warn tips\
\n\t\"-d,--dstdir\"    is specied dir for out";
	errpm: puts(usageChs);
	return -1;
	}
}
