/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Free under LGPL
*/

#ifndef  Cons_Space
#define  Cons_Space

#include "fsplus.h"
#include "fspio.h"

#define SPACELIMIT		30
#define LASTSPACE		29
extern fsp_lib *workspace[SPACELIMIT];
#define	libhb		workspace[0]

extern const char *pExeNam[];
extern const char curSpace[], RLS[];

extern int  runinginfo /* show  during script */;

extern void setCurPd(fsp_lib *lib);

extern int putFspAs(fsp_lib *lib, int space);

extern int indexUsedLib(const char *fn, const char *inpPath);
extern char *sysIdRead(fsp_lib *lib, int numb);

__BEGIN_DECLS

extern void (*extDest)(void *);

extern fsp_lib *fspUse(const char *filenam, OpenSpace msg, int n);
/* n: -1 append workspace; -2 no workspace; >-1 is spe */

extern fsp_lib *fspSpace(const char *pth, OpenSpace msg, int n);
/* n: -1 append workspace; -2 no workspace; >-1 is spe */

extern fsp_lib *fspCreat(const char *fnam, const un_Int *pms, BOOL fastbuf);

extern void fspDestroy(fsp_lib *lib, void (*fun)(void *p) /* , void *pms */ );

__END_DECLS

#endif
