/*
	Write & edit by Linjianghua(Xempo) 2004-2006,2008-2011
	Free under LGPL
*/

#include <utime.h>
#include "fsptime.h"
#include "fspdir.h"
#include "numbtype.h"
#include "../objcom/comm.def"

FILE *rtlout, *logfp;

const char MemoChs[]="Memo";

BOOL out_scrn_same /* display on screen in same time  */;

union Cvt {
long long lVar;
int iVar;
short sVar;
char ch;
};

union uCvt {
unsigned long long lVar;
unsigned int iVar;
unsigned short sVar;
BYTE ch;
};

inline void outCvt(MAU *send,int t)
{/* text void is same effect in read, is defferecnt of input(free write) */
char *pt=send->buf, *buf;
if(t<Int_TypeCount &&pt){
  union Cvt  cvt;
  union uCvt *pUcvt=(union uCvt *)&cvt;
  int j, len=0,
	s=intType[t],
	intcnt=send->len/s;

	buf=(char *)malloc(send->len * 5 + 8/* safe */);/* 8bit alloc 4char */
	for(j=0;j<intcnt;j++,pt+=s){
		memcpy(&cvt, pt, s);
		len+=sprintf(buf+len,CvtFmt[t], t<int_type_count ? (s>1? (s==2 ? cvt.sVar : (s>4 ? cvt.lVar : cvt.iVar)) : cvt.ch) :
			(s>1? (s==2 ? pUcvt->sVar : (s>4 ? pUcvt->lVar : pUcvt->iVar))  : pUcvt->ch)
		 );
		}
	free(send->buf);
	send->len=--len;  /* -1 is del end(,) */
	send->buf=buf;
	}
}

inline void showMAU(FILE *fp,MAU *pdat, int type, BOOL msg)
{
if(pdat->buf){
  static char hdtag[]=" .";
  outCvt(pdat,type);
  if(msg){
    if(fp==stdout){
	if(getMsg)PrnTxt(0, 34, hdtag);
	else printf("\033[34m%s\033[0m ", hdtag);
	}
    else fwrite(hdtag,2,1,fp);
     }
    if(getMsg){
	if(pdat->len>60000)pdat->len=59999;
	pdat->buf[pdat->len]=0;
	getMsg(pdat->buf);
	}
    else {
	fwrite(pdat->buf,pdat->len,1,fp);
	fwrite("\n", 1,1,fp);
    }
    free(pdat->buf);
}
}

void releasAr(fsp_lib *lib, int cn, char **pms)
{
 int i, numb;
#define  mu1  1
 int dir1Val[mu1];
 static const char *dir1chs[mu1]={ "-f" },
  *_dir1chs[mu1]={"--force" };
// static const int dmk[5]={1, 2, 128, 256, Ch_Dir /* over file no ask when creat rtl-file */};
#define  mu2  1
 int dir2Val[mu2];
 memset(dir1Val, 0, sizeof(dir1Val));
 memset(dir2Val, 0, sizeof(dir2Val));
 static const char *dir2chs[mu2]={ "-t"  },
	*_dir2chs[mu2]={ "--type" };
 ProcOpt opt1={
	mu1,
	dir1chs, _dir1chs,
	dir1Val,
	0,
	NULL
	},
  opt2={
	mu2,
	dir2chs, _dir2chs,
	dir2Val,
	0,
	NULL
	};
      arglists *alst=procParas(cn, pms, &opt1, &opt2);
      if(alst==NULL||alst->argc<1){
	fspHB(I_None_60, True);
	showUsage(FSP_release);
	}
       else {
	char *pt=divPath(alst->argv[0],&numb);
	if(numNone){ fspHB(WrongOpera_22, 1); return; }
	fsp_dir *dir=DirOpen(lib->CurDir,pt);
	if(idxdscpt>0x7ffd){
	      static const char releaTmp[]="releaTmp",
		arEng[3][6]={"lzma", "bzip2", "gzip" };
	      const char *fn, *fn2, *outfn;
	      char txt[16], txt2[16], buf[1024];
	      FILE *readfp, *fp;
	      int idx, n=dir->DAUC;
	      BYTE *stat;
	      outfn=alst->argc>1 ? alst->argv[1] : NULL;
	      idx=0;
	      if(alst->subarg && alst->subarg->argc>0)
		for(idx=1; idx<4 && strcmp(alst->subarg->argv[0], arEng[idx-1]); idx++);
	      if(idx>3){
		msgShow(alst->subarg->argv[0]);
		fspHB(63, 1);
		idx=0;
		}
	      if( (stat=seekFCU(dir,numb,NULL, (NUMB_READ|ARCH_NORM) )) ){
		unsigned int alen, len, cn;
		dskadr_t *padr=getDAU(dir, stat, &alen, &len, 0);
		if(idx==0){
		    for(i=1; i<4 ; i++)
			if((stat[1]&(~15))==(1<<(4+i))){
		    		idx=i;	break;
				}
			}

		if(outfn)fn=outfn;
		else if(dir->DAUC>1 &&  len>0){
			MAU m;
			readDAU(dir, stat, &m, 1);
			fn=m.buf;
			}
		           else {
			(void)sprintf(txt, "%d.txt", numb);
			fn=txt;
			}

		if( idx ){
			static const char *extNam[3]={"lzma", "bz2", "gz" };
			fn2=fn;
			fn=releaTmp; i=0;
			while(access(fn, F_OK)==0 && i<20000){
				(void)sprintf(txt2, "%s%d", releaTmp, ++i);
				fn=txt2;
				}
			fn=catstr(fn, extNam[idx-1], '.');
			}
		  fp=fopen64(fn, "wb");
		  if(fp==NULL){
			idxdscpt=11;
			if(fn!=txt&&fn!=outfn)free((void *)fn);
			return ;
			}
		  readfp=dir->lib->fpt;
		  fseek(readfp, *padr, 0);
		  struct archstat archst;
		  fread(&archst, sizeof(struct archstat), 1, readfp);
		  while(len>0){
			cn= len >1024 ? 1024 : len;
			fread(buf, cn, 1, readfp);
			fwrite(buf, cn, 1, fp);
			len-=cn;
			}
		  if(idx < 1){
			fchmod(fp->_fileno, archst.mode);
			fchown(fp->_fileno, archst.uid, archst.gid);
			}
		  fclose(fp);
		  struct  utimbuf  utm;
		  cvttim(&utm.modtime, stat+FCU_TimePos);
		  utm.actime=utm.modtime;
		  if(idx > 0){
			static const char *cmdstr[3]={"lzma -cd", "bzip2 -cd", "gzip -cd" },
				*cmdstr2[3]={"lzma -fcd", "bzip2 -fcd", "gzip -fcd" };
			const char *tmp, *cmd=catstr(dir1Val[0] ? cmdstr2[idx-1] : cmdstr[idx-1], fn, 32);
			tmp=catstr(cmd, ">", 32);
			free((void *)cmd);
			cmd=catstr(tmp, fn2, 32);
			free((void *)tmp);
			system(cmd);
			free((void *)cmd);
			chmod(fn2, archst.mode);
			chown(fn2, archst.uid, archst.gid);
			utime(fn2, &utm);
			remove(fn);
			if(fn2!=txt&&fn2!=outfn)free((void *)fn2);
		  }
		  else utime(fn, &utm);
		  if(fn!=txt&&fn!=outfn)free((void *)fn);
		  free(stat);
	    }
	    else reportBug();
	}
	}
if(alst)argsFree(alst);
}

BOOL numSelect(fsp_lib *lib, char **pms,char *extparm,int nCom)
{
 MAU *mau;
 static FILE *showfp; /*  >> display.txt  */
 static const char putchr[]="\nDisplay %s/%ld\n";
 int numb, n, j, i, len, type;
 BYTE  *stat=NULL;
 FILE *fp;
 fsp_dir *dir;
 char  *pt=divPath(pms[0],&numb);
 if(numNone){ fspHB(WrongOpera_22, 1); return False; }
 dir=DirOpen(lib->CurDir,pt);
 if(idxdscpt>0x7ffd){
   int style=dir->Format;
   switch(nCom){
   case FSP_log : if(out_scrn_same)fp=stdout;	   
		else {
			if(logfp==NULL)logfp=fopen("fsplus.log","w");
			fp=logfp;
			if(fp==NULL)goto _skp_;
		}
		break;
   case FSP_output : if(showfp==NULL){
			showfp=fopen("display.txt", "w");
			j=1;
		}
		else j=0;
	fp=showfp;
	if(fp==NULL)goto _skp_;
	pt= isNormDir(dir) ? pdPathNam(dir,NULL,0) : (char *)SPC;
	fprintf(fp, putchr+j, pt, numb);
	if(pt!=SPC)free(pt);
   default : fp=stdout;/* stdout define as &_stream[1] */
   }
#ifdef			_Simple_Base_
   if(style&SimpleBase){/* is #-style */
     static const char fmt[]="%s  ";
     SDBCU *ds=(SDBCU *)SDBseek(dir,numb,NUMB_READ);
     if(ds){
	stat=GetNo(lib,dir,ds);
	if(stat){ char *ptr=NULL;
	  for(len=0, i=0;i<dir->cols; len+=dir->FieldLen[i++]){
	    pt=(char *)(stat+len);
	    switch(dir->DataType[i]){
	    case 'c' : n=strlen(pt);	j=dir->FieldLen[i];
		if(n>=j){
		  ptr=(char *)malloc(j+2);
		  memcpy(ptr,pt,j); ptr[j]=0; pt=ptr;
		}
		fprintf(fp, fmt, pt);
		if(ptr==pt)free(ptr);
		break;
	    case 'm' : fprintf(fp, fmt, MemoChs);
		break;
	    case 't' : fprintf(fp, fmt, fspAscTim((BYTE *)pt));
		break;
	    case 's' : fprintf(fp,"%d  ",*(_Int *)pt);	break;
	    case 'i' : fprintf(fp,"%d  ",*(int *)pt);	break;
	    case 'l' : fprintf(fp,"%lld  ",*(long long*)pt);	break;
	    case 'f' : fprintf(fp,"%f  ",*(float *)pt);	break; 
	    case '$' : fprintf(fp,"%lf  ",*(double *)pt);
	   }
	}
	free(stat);
	printf("\n");
	}
//	else fprintf(fp,"# error\n");
     }
     else fprintf(fp,"#Numb invalid\n");
   }   else 
#endif
     {
	n=dir->DAUC;      	mau=MAUalloc(n);
	if(stat=num_read(dir,numb,mau,n,  0 )){
	  BYTE *types=NULL;
	  rtlout=fp;
	  if(extparm&&*extparm){
		types=(BYTE *)malloc(n);
		comExtPara(extparm,types, NULL, n, _void/* '-' */);
		}
	  else if(isType(style))types=stat+FCU_TypePos( style ); // CvtTypeTxt(stat+(isMode(style)? 2:1),types,n);
	     /*else memset(types,_void,n);*/
	  for(j=0;j<n;j++)showMAU(fp,mau+j, types ? types[j] : (int)_void, n>1);
	  if(isType(style)){
	      const char *chs;
	      if(nCom!=FSP_output&&nCom!=FSP_log)PrnTxt(1,  3, "Type:");
	      for(j=0,len=7;j<n;j++){
		chs=TypeStr[types[j]];
		if(nCom!=FSP_output&&nCom!=FSP_log){
			i=strlen(chs);
			PrnTxt(len, mau[j].len? 7:14, chs);
			len+=i+1;
			}
		else fprintf(fp," %s", chs);
		}
	    fprintf(fp,"\n");
	  }
/*	fprintf(fp,"\t%s\n",fspAscTim(FCU_GetDate(stat)) );
	if(nCom==FSP_output)fprintf(fp,"\n");
*/
	  if(types)free(types);
	  free(stat);
     	}
	else _err_: reportBug();
	free(mau);
     rtlout=stdout;
    }
_skp_:  if(isNormDir(dir)&&dir!=lib->CurDir)free(dir);
 }
 else reportBug();
return stat!=NULL;
}

