/*
	Write by xempo 2014
	Free under LGPL
*/

#ifndef    LIST_OPERA
#define  LIST_OPERA

class QImage;

typedef struct {
unsigned long long siz;
time_t mtm;
int mode, uId, gId, icon;
time_t atm;
const char *uName, *gName, *type;
QImage *ico;
void *item;
bool isImg, isLnk, isLost, isNoRead;
}ListOptions;

class ListOpera
{
public :
ListOpera();
~ListOpera();
void preAdd(int a, int ico);
void add(ListOptions *op, int prealloc=128);
void remove(int idx);
void insert(ListOptions *op, int idx);
void clear();
void setZore(){ pre_cnt=0; cnt=0; }
// void copy(const ListOpera &c);
// void dup(const ListOpera &d);

int count() const
{ return cnt; }

int preCount() const
{ return pre_cnt; }

ListOptions *last() const
{ return cnt ? lo+cnt-1 : NULL; }

ListOptions *first() const
{ return cnt ? lo : NULL; }

private :
ListOptions *lo;
int pre_cnt, cnt;
};

#endif
