/*
	Write by xempo
	Free under LGPL
*/
#include "filesan.h"
#include "fspattr.h"
#include "infor.h"
#include "shellcom.h"
#include "chMT.h"
#include "fsptime.h"
#include "dirext.h"
#include "fcu.h"
#include "../rtdata/en/target/fspattr.h"

const char FspAttrib[]="FspAttr";

char *fspdirnam;
int loopMsg;

void getDirNam(fsp_dir *dir, int msg)
{
loopMsg=msg;
fspdirnam=pdPathNam(dir, NULL,0);
}

#define  _fspattr_  _setting_

FspAttr::FspAttr(QWidget *par, fsp_dir *dir1) : SettingWidget(par, FspAttrib),
	pDir(dir1), dir(*dir1), pIt((LVItem *)((Filesan *)par)->getTreeView()->selectedItem())
{
}

FspAttr::~FspAttr()
{ }

void FspAttr::execu(const int w, const int h, const int id)
{
#define  hg  23
char buf[1200];
SettingWidget::execu(w,h,id);
creatGenTab()
pdInfoMore( &dir, buf, 2);
QLabel *brow=new QLabel(QString::fromUtf8(buf), tab1);
brow->setFrameStyle(QLabel::Panel|QLabel::Sunken);
brow->setGeometry( hg, hg, tabw-2*hg,
	tabh-(hg)-fntSz-(fntSz*2)  );
brow->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );
setIcon(*pixmapLoad(fspSpaceImg));
show();

read=new QCheckBox(QString::fromUtf8(readChs), tab2);
read->setChecked(R=dir.mode&FSP_MR);
write=new QCheckBox(QString::fromUtf8(writeChs), tab2);
write->setChecked(W=dir.mode&FSP_MW);
hide=new QCheckBox(QString::fromUtf8(hideChs), tab2);
hide->setChecked(H=dir.mode&FSP_MH);
subchk=new QCheckBox(QString::fromUtf8(subdirChs), tab2);

nedt=new QLineEdit(tranText(strCodec, dir.name), tab2);
tedt=new QLineEdit(fspAscTim(dir.datebuf), tab2);
int combH=fntSz*3/2;
nedt->setGeometry(fntSz, fntSz, tabw-2*fntSz, combH);
read->setGeometry(fntSz*2, fntSz+fntSz*3, tabw-3*fntSz, combH);
write->setGeometry(fntSz*2, fntSz+fntSz*5, tabw-3*fntSz, combH);
hide->setGeometry(fntSz*2, fntSz+fntSz*7, tabw-3*fntSz, combH);
tedt->setGeometry(fntSz, fntSz+fntSz*10, tabw-2*fntSz, combH);
subchk->setGeometry(fntSz*4, tabh-fntSz*4, 12*fntSz, combH);
}

static QMetaObjectCleanUp cleanUp_FspAttr( FspAttrib, &FspAttr::staticMetaObject );

QMetaObject *FspAttr::metaObj = 0;
QMetaObject* FspAttr::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "Sure()" , &slot_0_0, QMetaData::Private },
	{ "pReturn()" , &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(FspAttrib, QWidget::staticMetaObject(), slot_tbl, 2,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_FspAttr.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool FspAttr::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool FspAttr::qt_invoke( int _id, QUObject* _o )
{
static const char mcmd[]="-M";
int  i, n, sw=_id - staticMetaObject()->slotOffset();
char *pms[5], buf[10];
Filesan *fs=(Filesan *)parentWidget();
switch(sw){
case 1 :
case 0 :	if(fs->getModul()==_FSPLUS){
	struct tm dt;
	fsp_lib *fsp;
	bool _r, _w, _h,
		bt, bm, sub;
	fs->fsKillTimer();
	fs->busiedCursor();
	fsp=dir.lib;
	if((LVItem *)fs->getTreeView()->selectedItem()!=pIt)pDir=&dir;
	else   for(i=0; i<fsp->cnt_usedir; i++)
		if(fsp->usedirs[i]->own_adr==dir.own_adr){
			pDir=fsp->usedirs[i];
			break;
		}
	pms[0]=(char *)".";
	const QString T(tedt->text().local8Bit());
	smtime(T, &dt);
	fspTime(mktime(&dt), (BYTE *)buf);
	if(sub=subchk->isChecked()){ pms[3]=(char *)"-t"; pms[4]=NULL; n=4;  }
	else { pms[3]=NULL; n=3; }
	const QString S(nedt->text().local8Bit());
	_r=read->isChecked();
	_w=write->isChecked();
	_h=hide->isChecked();
	close();
	if( bm=(R!=_r||_w!=W||_h!=H) ){
		i=0;
		if(_r)buf[i++]='r';
		if(_w)buf[i++]='w';
		if(_h)buf[i++]='h';
		buf[i]=0;
		if(_w){
			pms[1]=(char *)mcmd;	pms[2]=buf;
			chMT(pDir,  n, pms, FSP_chmode); // get fspdirnam
		}
		}
	if(bt=(memcmp(buf, pDir->datebuf, FspTmLen)!=0)){
		pms[1]=(char *)"-T";	pms[2]=(char *)(const char *)T;
		chMT(pDir,  n, pms, FSP_chdate);
		}
	if(bm&&_w==false){
		pms[1]=(char *)mcmd;	pms[2]=buf;
		chMT(pDir,  n, pms, FSP_chmode); // get fspdirnam
		}
	if(bm==false&&bt==false)
		fspdirnam=pdPathNam(pDir, NULL, 0);
	LVItem *it=fs->getTreeView()->seekFspDir(fsp, fspdirnam, FSP_chmode);
	free(fspdirnam);

	if(strcmp(S, pDir->name)){
		fsp_dir dirbuf, *dir1=getPdParent(fsp, &dirbuf, pDir->parent_adr);
		if(pdRen(dir1, pDir->name, S)){
			it->setText(0, QString::fromUtf8(S));
			it->_set_name(S);
			}
		if(dir1!=&dirbuf)pd_close(dir1,2);
		}
	if(bm)fs->getTreeView()->freshItem(it, pDir, sub);
	fs->fsStartTimer();
	fs->normalCursor();
	}
	break;
default : return QWidget::qt_invoke( _id, _o );
}
return true;
}
